// **************************************
// Phantomasa 3 : Fundamentally Loathsome
// **************************************

// En este cdigo fuente se utiliza la palabra "CONVEYOR".
// Nunca antes en mi vida haba usado esta palabra, y me encanta.
// "CONVEYOR". No suena super guapo? Pues la uso en este fuente.
// Si la encuentras, ganas un pin de "TOY MORAO".

#pragma output STACKPTR=61440

// Si os fijis, es lo que ocupa una pantalla sin atributos, pero multiplicado
// por diez... Ah, la belleza de la informtica! ;-)

// Includes:

#include <spritepack.h>
#include "externs.h"			// Mira: esto permite definir aqu externs y poner los datos en plan guarro al final
								// Esto mola sobre todo porque as paginar es mucho ms fcil (e divertente).
#include "beeper.h"
								
// Defines:

#define PUCRUNCH		32463
#define EJCROL1			31064	// bytes 31064, 1392
#define EJCROL2			28884	// bytes 28884, 2180
#define EJCROL3			28193	// bytes 28193, 691
#define EJCROL4			27439	// bytes 27439, 754
#define INTERLUDE		27181	// bytes 27181, 258
#define	ESCAPE			27028	// bytes 27028, 153
#define	ENDING			25526	// bytes 25526, 1502
#define TITLE			24445	// bytes 24445, 1081

// Estados:

#define STATE_IDLE 		0
#define STATE_WLEFT		1
#define STATE_WRIGHT	2
#define STATE_WUP		3
#define STATE_WDOWN		4
#define STATE_DEAD		5
#define STATE_APARECE 	6
#define STATE_SLEFT		7
#define STATE_SRIGHT	8

#define FACING_LEFT 	0
#define FACING_RIGHT 	1
#define FACING_UP		2
#define FACING_DOWN		3

#define NUM_BULLETS		2

#define INI_POWER		3
#define INI_LIVES		3
#define MAX_BULLETS 	15

// Struct/types:

extern struct sp_Rect *sp_ClipStruct;
extern char asm_number[1];
extern char *Rand8;
struct sp_UDK keys;

// (C) Mojontwins chapuzas 2008

typedef struct {
	unsigned char state; 	// 0 idle, 1 left, 2 right, 3 up, 4 down;
	char x, y, ct;
	char lives;
	unsigned int score;
	char bullets;
	char power;
	unsigned char sal, nu;
	unsigned char frame;
	unsigned char step;
	unsigned char paso;
	unsigned char facing;
	unsigned char colliding;
} PERZONAE;

typedef struct {
	int x;
	unsigned char y, t;
} OBSTACLE;

typedef struct {
	unsigned char x, y, mx, status;
} MOVIL;

typedef struct {
	char x, y, mx;
	char t, ct, delay;
	char frame, frame_offset;
} BICHARRACO;

typedef struct {
	int x;
	unsigned char y, t, status;	
} OBJETO;

typedef struct {
	unsigned int 	backdrop;
	OBSTACLE	 	*obstacles;
	unsigned char	num_obstacles;
	int				last_object_x;
	unsigned char	offset_enemigos;
	unsigned char	num_enemigos;
	unsigned char	*tiles;	
	unsigned char 	auto_advance_me;
} FASES;

// Definicin de los obstculos:

OBSTACLE obstacles_1 [] = {
	{2, 13, 0},
	{2, 9, 0},
	{28, 6, 1},
	{52, 13, 2},
	{74, 6, 3},
	{97, 13, 1},
	{110, 13, 2},
	{120, 6, 1},
	{132, 6, 3},
	{160, 13, 1},
	{180, 6, 3},
	{184, 6, 3},
	{200, 13, 0},
	{220, 6, 3},
	{224, 6, 0},
	{240, 9, 1},
	{240, 13, 0}
};

OBSTACLE obstacles_2 [] = {
	{2, 9, 4},
	{2, 13, 5},
	{23, 13, 8},
	{19, 13, 9},
	{35, 6, 8},
	{39, 6, 8},
	{52, 9, 6},
	{52, 13, 7},
	{70, 13, 8},
	{90, 6, 8},
	{110, 13, 9},
	{118, 9, 6},
	{118, 13, 7},
	{139, 6, 10},
	{162, 13, 10},
	{174, 13, 9},
	{200, 13, 9},
	{212, 9, 6},
	{212, 13, 7},
	{238, 13, 10},
	{256, 13, 10},
	{280, 13, 10},
	{280, 9, 9},
	{320, 9, 6},
	{320, 13, 7},
	{336, 13, 9},
	{350, 9, 4},
	{350, 13, 5}
};
		
OBSTACLE obstacles_3 [] = {
	{2, 9, 13},
	{2, 13, 14},
	{28, 13, 13},
	{32, 13, 13},
	{48, 6, 15},
	{52, 6, 15},
	{72, 9, 11},
	{72, 13, 12},
	{84, 13, 15},
	{112, 13, 15},
	{116, 13, 15},
	{140, 9, 11},
	{140, 13, 12},
	{160, 13, 13},
	{176, 13, 14},
	{176, 9, 11},
	{196, 9, 11},
	{196, 13, 12},
	{216, 6, 15},
	{224, 13, 14},
	{252, 13, 13},
	{272, 13, 13},
	{292, 9, 11},
	{292, 13, 12},
	{312, 9, 13},
	{314, 13, 14}
};

OBSTACLE obstacles_4 [] = {
	{2, 13, 13},
	{22, 13, 14},
	{32, 13, 13},
	{48, 6, 13},
	{60, 6, 17},
	{60, 13, 18},
	{78, 6, 16},
	{92, 13, 19},
	{95, 13, 19},
	{120, 13, 20},
	{130, 13, 21},
	{142, 13, 16},
	{146, 13, 17},
	{150, 13, 18},
	{170, 8, 17},
	{186, 13, 19},
	{200, 6, 17},
	{220, 6, 17},
	{228, 13, 16},
	{244, 13, 13},
	{270, 13, 14},
	{274, 13, 19},
	{300, 6, 16},
	{304, 6, 17},
	{330, 13, 21}
};

// Este array contiene informacin sobre los 
// recursos intercambiables de cada fase.

// En cada member tenemos:
// backdrop, obstacles, num_obstacles, last_object_x, offset_enemigos, num_enemigos, tiles

FASES fases [] = {
	{EJCROL1, obstacles_1, 17, 240,  0, 7, gfx_tiles_fase_1, 0},
	{EJCROL2, obstacles_2, 28, 350,  8, 7, gfx_tiles_fase_2, 0},
	{EJCROL3, obstacles_3, 26, 312, 16, 7, gfx_tiles_fase_3, 0},
	{EJCROL4, obstacles_4, 25, 330, 24, 7, gfx_tiles_fase_4, 1}
};	
unsigned char fase;	

// Este array muestra qu frames de animacin 
// usar cada bicharraco.

char bicharraco_g [] = {
	
	// Bicharracos fase 1:
	
	// 0
	0, 1, 2, 1,				// bicharraco 1  <--
	11, 12, 11, 12,			// bicharraco 2  -->
	9, 9, 10, 10,			// bicharraco 3  <--
	9, 9, 10, 10,			// bicharraco 4  -->
	11, 12, 11, 12,			// bicharraco 5  <--
	7, 8, 7, 8,				// bicharraco 6  -->
	13, 14, 15, 14,			// bicharraco 7  <--
	3, 4, 5, 6,				// ecplocion hoygan
	
	// Bicharracos fase 2:
	
	// 8
	16, 17, 18, 17,			// <--			
	19, 20, 19, 20,			// -->
	21, 22, 21, 22,			// <--
	21, 22, 21, 22,			// -->
	23, 24, 25, 24,			// <--
	26, 26, 26, 26, 		// -->
	26, 26, 26, 26,			// <--
	3, 4, 5, 6,				// ecplocion hoygan
	
	// Bicharracos fase 3:
	
	// 16
	27, 28, 29, 28,			// <--
	32, 32, 32, 32, 		// -->
	30, 30, 31, 31,			// <--
	33, 34, 33, 34,			// -->
	33, 33, 34, 34, 		// <--
	35, 36, 37, 36,			// -->
	36, 37, 36, 35,			// <--
	3, 4, 5, 6,				// ecplocion hoygan
	
	// Bicharracos fase 4:
	
	// 24
	38, 38, 38, 38,			// <--
	39, 39, 39, 39, 		// -->
	40, 41, 40, 41,			// <--
	42, 43, 42, 43,			// -->
	42, 43, 42, 43,			// <--
	44, 44, 44, 44, 		// -->
	44, 44, 44, 44, 		// <--
	45, 46, 47, 48			// Ecpocion, hoygan.
	
};

// Definimos los perzonae del juego.

PERZONAE phasa;
BICHARRACO bicharraco [2];
MOVIL bullet [NUM_BULLETS];
OBJETO cosa [10];

// Colores y grficos de cada item

char cosa_g [4] = {0, 242, 243, 245};
char cosa_c [4] = {0, 14, 12, 13};

// Extern data:

#asm
	LIB SPCClipStruct
._sp_ClipStruct
	defw SPCClipStruct
._asm_number 
	defb 0
#endasm

// Globals:

char play = 0;
unsigned int asm_int;
unsigned char halflife = 0;
unsigned char quarterlife = 0;
unsigned char scroll_halflife = 0;
unsigned char scroll_quarterlife = 0;
unsigned char tiene_bisho;
unsigned char *allpurposepuntero;
unsigned char joykeyboard = 0;		// Keyboard == 0; Joystick == 1;
int campos = 0;
unsigned char fire_pressed;

unsigned char buffer_phasa [42];
unsigned char buffer_bicharracos [36];

struct sp_Rect rectangulo;
struct sp_Rect rectangulo_enem;

// Variables que controlan aspectos de la fase actual:

unsigned int 	ingame_backdrop;
OBSTACLE	 	*ingame_obstacles;
unsigned char	ingame_num_obstacles;
int				ingame_last_object_x;
unsigned char	ingame_offset_enemigos;
unsigned char	ingame_num_enemigos;
unsigned char	*ingame_tiles;
unsigned char 	ingame_auto_advance_me;	// Para fases tipo conveyor.

// Funciones de apoyo, la minimojonlib cambiante.
/*
void *my_malloc(unsigned int bytes) {
   return sp_BlockAlloc(0);
}

void *u_malloc = my_malloc;
void *u_free = sp_FreeBlock;
*/
void ejcrol_asm_container () {
	#asm
		.escrolleft
		                 
		;; calculamos hl
		
		ld   a, (_asm_int) ; nos traemos el numero de linea
		ld   l,a           ; lo guardamos para no tener que pillarlo otra vez
		add  a, $40        ;
		and  $58           ; nos quedamos con el tercio + $40
		ld   h, a
		
		ld   a, l          ; recuperamos el numero de linea
		and  7             ; linea dentro del tercio: linea MOD 8
		rrca
		rrca
		rrca               ; rotamos pa la derecha del byte
		ld   l, a   
		
		;;
		
		ld   a, 8          ; ocho lineas...
	.buclebmp1
		push af
		
		ld   d,h
		ld   e,l
		push bc
		push hl
		ld   a,(hl)
		inc  hl
		ld   bc, 31
		ldir
		dec  hl
		ld   (hl),a
		pop  hl
		pop  bc
		
		pop  af
		inc  h
		dec  a
		jr   nz, buclebmp1
		
		ret
		
	.escrolright
	
		;; calculamos hl
		
		ld   a, (_asm_int) ; nos traemos el numero de linea
		ld   l,a           ; lo guardamos para no tener que pillarlo otra vez
		add  a, $40        ;
		and  $58           ; nos quedamos con el tercio + $40
		ld   h, a
		
		ld   a, l          ; recuperamos el numero de linea
		and  7             ; linea dentro del tercio: linea MOD 8
		rrca
		rrca
		rrca               ; rotamos pa la derecha del byte
		or   31            ; columna 31
		ld   l, a   
		
		;;
		
		ld   a, 8          ; ocho lineas...
	.buclebmp2
		push af
		
		ld   a,l
		ld   l,a
		ld   d,h
		ld   e,l
		push bc
		push hl
		ld   a,(hl)
		dec  hl
		ld   bc,31
		lddr
		inc  hl
		ld   (hl),a
		pop  hl
		pop  bc
		
		pop  af
		inc  h
		dec  a
		jr   nz, buclebmp2
		
		ret
	#endasm		
}

void fade_out () { 
	
	unsigned char i;
	
	// El segundo programa de ms de 5 lineas en Z80 ASM de na_th_an
	// Optimizado por Metalbrain
	// Esto "oscurece" un paso la pantalla. Llamado 8 veces la dejar en negro
	
	for (i = 0; i < 8; i ++) {	
		#asm 
			ld   e, 3               ; 3 tercios 
			ld   hl, 22528          ; aqu empiezan los atributos 
			halt                    ; esperamos retrazo. 
		.fade_out_bucle  
			ld   a, (hl )           ; nos traemos el atributo actual 
		 	
			ld   d, a               ; tomar atributo 
			and  7                  ; aislar la tinta 
			jr   z, ink_done        ; si vale 0, no se decrementa 
			dec  a                  ; decrementamos tinta 
		.ink_done 
			ld   b, a               ; en b tenemos ahora la tinta ya procesada. 
			
			ld   a, d               ; tomar atributo 
			and  56                 ; aislar el papel, sin modificar su posición en el byte 
			jr   z, paper_done      ; si vale 0, no se decrementa 
			sub  8                  ; decrementamos papel restando 8 
		.paper_done 
			ld   c, a               ; en c tenemos ahora el papel ya procesado. 
			ld   a, d  
			and  192                ; nos quedamos con bits 6 y 7 (BRIGHT y FLASH) 
			or   c                  ; aadimos paper 
			or   b                  ; e ink, con lo que recompuesto el atributo 
			ld   (hl),a             ; lo escribimos, 
			inc  l                  ; e incrementamos el puntero. 
			jr   nz, fade_out_bucle ; continuamos hasta acabar el tercio (cuando L valga 0) 
			inc  h                  ; siguiente tercio 
			dec  e 
			jr   nz, fade_out_bucle ; repetir las 3 veces 
		#endasm 
	}
}

unsigned char rand () {
	unsigned char res;
	
	#asm
			ld a,r
	._Rand8	;ld	a,9		; Seed is usually 0
			;ld	b,a
			;add	a,a
			;add	a,a
			;add	a,b
			;inc	a		; another possibility is ADD A,7
			;ld (_Rand8+1),a
			ld (_asm_number), a
	#endasm

	res = asm_number [0];

	return res;
}


void kjjjj () {
	
	// Original de Daniel de la Cruz
	// Publicado en MH #197, pg 24.
	char i;
	
	for (i = 0; i < 8; i ++) {
		#asm
			ld	c, 1
		.kjjjj_bucle
			ld 	a, 255
			inc	c
			ld	b, 198
		.kjjjj_stop
			djnz kjjjj_stop
			outi
			cp	c
			jr	nz, kjjjj_bucle
		#endasm	
	}
	
	sp_Border (0);
}

void blackout_everything () {
	unsigned char *origin;

	origin = (unsigned char *) 22528;
	while (origin < 23296) {
		*origin = 0;
		origin ++;
	}
}

void uncrunch (int address) {
	unsigned char *origin;
	unsigned char *destiny;
	unsigned char msb, lsb;

	origin = (unsigned char *) PUCRUNCH;
	destiny = (unsigned char *) PUCRUNCH + 2;

	msb = address >> 8;
	lsb = address & 255;
	
	*origin = lsb;
	origin ++;
	*origin = msb;

	*destiny = 0;
	destiny ++;
	*destiny = 64;

	// Antes de llamar a pucrunch, tintamos la pantalla de negro
	// para que no se vea tan feo:

	blackout_everything ();

	#asm
		di
		call PUCRUNCH + 4
		ei
	#endasm
}

unsigned char attr (char x, char y) {	
	char *res = (char *) (22528 + x + (y << 5));
	return (*res);
}

void do_scroll_left () {
	scroll_halflife = !scroll_halflife;
	scroll_quarterlife = (scroll_quarterlife + 1) & 3;
	
	if (!scroll_quarterlife)
		for (asm_int = 1; asm_int < 5; asm_int ++) {
			#asm
				call escrolleft
			#endasm
		}
		
	if (!scroll_halflife) {
		if (!ingame_auto_advance_me) {
			asm_int = 17;
			#asm
				call escrolleft
			#endasm
		}
		asm_int = 18;
		#asm
			call escrolleft
		#endasm
	}
	
	for (asm_int = 19; asm_int < 23; asm_int ++) {
		#asm
			call escrolleft
		#endasm
	}
}

void do_scroll_right () {
	scroll_halflife = !scroll_halflife;
	scroll_quarterlife = (scroll_quarterlife + 1) & 3;
	
	if (!scroll_quarterlife)
		for (asm_int = 1; asm_int < 5; asm_int ++) {
			#asm
				call escrolright
			#endasm
		}
		
	if (!scroll_halflife) {
		asm_int = 17;
		#asm
			call escrolright
		#endasm
		asm_int = 18;
		#asm
			call escrolright
		#endasm
	}
	
	for (asm_int = 19; asm_int < 23; asm_int ++) {
		#asm
			call escrolright
		#endasm
	}
}

// Hacen falta a partir de aqu, y es ms seguro que queden por atrs.
// Qu me gusta el C, que te permite ser todo lo guarro que quieras!

#include "tilprites.h"

// eog (end of guarrerida)

void put_4x4_tilprite ( char x, unsigned char y, unsigned char frame) {
	int ct;
	unsigned char xx, yy;
	unsigned char atr, til;
	
	// ct = frame * 32
	ct = (frame << 5);
	
	for (yy = 0; yy < 4; yy ++)
		for (xx = 0; xx < 4; xx ++) {
			atr = tp_4x4 [ct ++];
			til = tp_4x4 [ct ++];
			if (atr != 0)
				if (x + xx >= 0 && x + xx < 32)
					sp_PrintAtInv (y + yy, x + xx, atr, til);
		}
}

void del_4x4_tilprite (char x, unsigned char y) {
	unsigned char xx, yy;
	for (yy = 0; yy < 4; yy ++)
		for (xx = 0; xx < 4; xx ++)
			if (x + xx >= 0 && x + xx < 32)
				sp_PrintAtInv (y + yy, x + xx, 9, 0);
}

void put_3x3_tilprite (char x, unsigned char y, unsigned char frame) {
	int ct;
	unsigned char xx, yy;
	unsigned char atr, til;
	
	// ct = frame * 18 = frame * 16 + frame * 2
	ct = (frame << 4) + (frame << 1);
	
	for (yy = 0; yy < 3; yy ++)
		for (xx = 0; xx < 3; xx ++) {
			atr = tp_3x3 [ct ++];
			til = tp_3x3 [ct ++];
			if (atr != 0)
				if (x + xx >= 0 && x + xx < 32)
					sp_PrintAtInv (y + yy, x + xx, atr, til);
		}
}

void del_3x3_tilprite (char x, unsigned char y) {
	unsigned char xx, yy;
	for (yy = 0; yy < 3; yy ++)
		for (xx = 0; xx < 3; xx ++)
			if (x + xx >= 0 && x + xx < 32)
				sp_PrintAtInv (y + yy, x + xx, 9, 0);
}

void put_3x7_tilprite (unsigned char x, unsigned char y, unsigned char frame) {
	int ct;
	unsigned char xx, yy;
	unsigned char atr, til;
	
	// ct = frame * 42 [ frame * 32 + frame * 8 + frame * 2 ]
	ct = (frame << 5) + (frame << 3) + (frame << 1);
	
	for (yy = 0; yy < 7; yy ++)
		for (xx = 0; xx < 3; xx ++) {
			atr = tp_3x7 [ct ++];
			til = tp_3x7 [ct ++];
			if (atr != 0)
				sp_PrintAtInv (y + yy, x + xx, atr, til);
		}
}

void del_3x7_tilprite (char x, unsigned char y) {
	unsigned char xx, yy;
	for (yy = 0; yy < 7; yy ++)
		for (xx = 0; xx < 3; xx ++)
			sp_PrintAtInv (y + yy, x + xx, 9, 0);
}

void marcador_lives () {
	sp_PrintAtInv (23, 0, 66, 244);
	sp_PrintAtInv (23, 1, 71, 246 + (phasa.lives / 10));
	sp_PrintAtInv (23, 2, 71, 246 + (phasa.lives % 10));
}

void marcador_power () {
	sp_PrintAtInv (23, 8, 69, 245);
	sp_PrintAtInv (23, 9, 71, 246 + (phasa.power / 10));
	sp_PrintAtInv (23, 10, 71, 246 + (phasa.power % 10));
}

void marcador_bullets () {
	sp_PrintAtInv (23, 16, 68, 243);
	sp_PrintAtInv (23, 17, 71, 246 + (phasa.bullets / 10));
	sp_PrintAtInv (23, 18, 71, 246 + (phasa.bullets % 10));
}

void print_int (unsigned char x, unsigned char y, unsigned char c, int n) {
	sp_PrintAtInv (y, x, c, 246 + (n / 10000));
	sp_PrintAtInv (y, x + 1, c, 246 + (n % 10000) / 1000);
	sp_PrintAtInv (y, x + 2, c, 246 + (n % 1000) / 100);
	sp_PrintAtInv (y, x + 3, c, 246 + (n % 100) / 10);
	sp_PrintAtInv (y, x + 4, c, 246 + (n % 10));
}

void marcador_score () {
	sp_PrintAtInv (23, 26, 70, 242);
	print_int (27, 23, 71, phasa.score);
}

void mueve_bullets () {
	unsigned char i;
	unsigned char k;
	
	// Crea y menea las bullets.	
	
	k = sp_JoyKeyboard (&keys);
	
	for (i = 0; i < NUM_BULLETS; i ++)
		if (bullet [i].status) {
			bullet [i].x += bullet [i].mx;
			if (bullet [i].x == 0 || bullet [i].x == 32)
				bullet [i].status = 0;
		} else {
			if ((k & sp_FIRE) == 0 && !fire_pressed && phasa.bullets > 0) {
				phasa.bullets --;
				marcador_bullets ();
				fire_pressed = 1;
				bullet [i].status = 1;
				if (phasa.facing) {
					bullet [i].x = phasa.x - 1;
					bullet [i].mx = -1;
				} else {
					bullet [i].x = phasa.x + 4;
					bullet [i].mx = 1;
				}
				bullet [i].y = phasa.y + 2 + (phasa.state == STATE_WDOWN);
				peta_el_beeper (6);
			}	
		}
		
	if (k & sp_FIRE)
		fire_pressed = 0;
}

void mueve () {
	unsigned char i,aux,flag;
	
	// A ver, ejcrol falso... Es la primera vez que "simulo" un ejcrol,
	// y como de el pego me parto el cimbel.
	
	// Lo hago en plan mquina de estados, y as me distraigo, que me gucha.
	// Actualizacin: da el pego. Ahora me estoy partiendo el cimbel XD.
	
	// ** 
	
	// Mirad: smplemente aadiendo este bloque "if" puedo tener fases
	// tipo conveyor :)
		
	if (ingame_auto_advance_me) {
		
		// Si estamos en el suelo o sobre algo, nos arrastra:
		
		if (phasa.y == 10 || (!phasa.sal && 
			(attr (phasa.x    , phasa.y + 7) >= 64 || 
			attr (phasa.x + 1, phasa.y + 7) >= 64 ||
			attr (phasa.x + 2, phasa.y + 7) >= 64)))
			phasa.x --;
		
		// Y avanzamos la fase:
			
		campos ++;
		do_scroll_left ();
		
		for (i = 0; i < 2; i ++) 
			if (bicharraco [i].t) {
				bicharraco [i].x --;
				if (bicharraco [i].x < -2)
					bicharraco [i].t = 0;
			}
	} 
	
	// Ahora el saltino:
	
	i = sp_JoyKeyboard (&keys);
	
	if ((i & sp_UP) == 0) {
		if (phasa.y == 10 ||
			attr (phasa.x    , phasa.y + 7) > 64 || 
			attr (phasa.x + 1, phasa.y + 7) > 64 ||
			attr (phasa.x + 2, phasa.y + 7) > 64) {
			phasa.sal = 1;
			phasa.nu = 0;		
			peta_el_beeper (3);
		}						
	}
	
	switch (phasa.state) {
		case STATE_IDLE:
		
			// En el estado IDLE, puede pasar que pulsemos izquierda, derecha
			// salto o disparo, pasando al estado correspondiente.
			
			if ((i & sp_LEFT) == 0) {
				phasa.facing = 1;
				
				// Si podemos avanzar a la izquierda:
				
				if (attr (phasa.x -1, phasa.y) < 64 &&
					attr (phasa.x -1, phasa.y + 2) < 64 &&
					attr (phasa.x -1, phasa.y + 4) < 64 &&
					attr (phasa.x -1, phasa.y + 6) < 64 ) {
					phasa.x --;
					phasa.state = STATE_WLEFT;
					phasa.step = 0;
				}
			}	
			
			if ((i & sp_RIGHT) == 0) {
				phasa.facing = 0;
				
				// Si podemos avanzar a la derecha:
				
				if (attr (phasa.x +3, phasa.y) < 64 &&
					attr (phasa.x +3, phasa.y + 2) < 64 &&
					attr (phasa.x +3, phasa.y + 4) < 64 &&
					attr (phasa.x +3, phasa.y + 6) < 64 ) {
					phasa.x --;
					phasa.state = STATE_WRIGHT;
					phasa.step = 0;
				}
			}
			
			if ((i & sp_DOWN) == 0) {
				phasa.state = STATE_WDOWN;	
			}
			
			phasa.frame = 0;
			
			break;	
		
		case STATE_WDOWN:
			phasa.state = STATE_IDLE;
			
			if ((i & sp_DOWN) == 0) {
				phasa.state = STATE_WDOWN;
				phasa.step = 0;
				phasa.frame = 9 + phasa.facing;
			}
			break;	
		
		case STATE_WLEFT:
			phasa.state = STATE_IDLE;		// Por si no hay cambios...
			aux = 1;
			
			if ((i & sp_LEFT) == 0) {
				if (!(phasa.step & 1)) {	// Par
					phasa.state = STATE_WLEFT;
					phasa.x --;
				} else {
					aux = 0;
					phasa.x -=2;
					phasa.state = STATE_WLEFT;
				}
			}
			
			// colisin? Ajustar.
			
			flag = 0;
			while ( !(	attr (phasa.x - aux, phasa.y) < 64 &&
						attr (phasa.x - aux, phasa.y + 2) < 64 &&
						attr (phasa.x - aux, phasa.y + 4) < 64 &&
						attr (phasa.x - aux, phasa.y + 6) < 64) ) {
				phasa.x ++;
				flag = 1;
				//peta_el_beeper (2);
			}
			
			if (!ingame_auto_advance_me)
				while (phasa.x < 12) {
					phasa.x ++;
					campos --;
					do_scroll_right ();
					
					// Scroll de enemigos:
					
					for (i = 0; i < 2; i ++) 
						if (bicharraco [i].t) {
							bicharraco [i].x ++;
							if (bicharraco [i].x > 31) 
								bicharraco [i].t = 0;
						}
				}
				
			if (!flag) {
				phasa.step = (phasa.step + 1) & 3;
				if (phasa.step == 1)
					phasa.frame = 6;
				else if (phasa.step == 3)
					phasa.frame = 7;
				else
					phasa.frame = 5;
			}

			break;
			
		case STATE_WRIGHT:
			phasa.state = STATE_IDLE;		// Por si no hay cambios...
			aux = 3;
			
			if ((i & sp_RIGHT) == 0) {
				if (!(phasa.step & 1)) {	// Par				
					//aux = 2;
					phasa.state = STATE_WRIGHT;
					phasa.x ++;
				} else {
					aux = 2;
					phasa.x +=2;
					phasa.state = STATE_WRIGHT;
				}
			} 

			// colisin? Ajustar.
			flag = 0;
			while ( !(	attr (phasa.x + aux, phasa.y) < 64 &&
						attr (phasa.x + aux, phasa.y + 2) < 64 &&
						attr (phasa.x + aux, phasa.y + 4) < 64 &&
						attr (phasa.x + aux, phasa.y + 6) < 64) ) {
				phasa.x --;
				flag = 1;
				//peta_el_beeper (2);
			}
			
			while (phasa.x > 19) {
				phasa.x --;
				campos ++;
				do_scroll_left ();
				
				for (i = 0; i < 2; i ++) 
					if (bicharraco [i].t) {
						bicharraco [i].x --;
						if (bicharraco [i].x < -2)
							bicharraco [i].t = 0;
					}
			}
			
			if (!flag){						
				phasa.step = (phasa.step + 1) & 3;
				if (phasa.step == 1)
					phasa.frame = 2;
				else if (phasa.step == 3)
					phasa.frame = 3;
				else
					phasa.frame = 1;
			}
						
		default:
		
	}

	if (phasa.sal) {	
		if (phasa.nu == 5) {
			phasa.sal = 0;
		} else  {
			if (phasa.y >5 && 
				attr (phasa.x    , phasa.y - 1) < 64 &&
				attr (phasa.x + 1, phasa.y - 1) < 64 &&
				attr (phasa.x + 2, phasa.y - 1) < 64) {	
					
				phasa.y --;
				phasa.frame = 9 + phasa.facing;
			} else {
				phasa.sal = 0;
			}
		}
		
		phasa.nu ++;
	}

	if (!phasa.sal && phasa.y != 10) {
		if (attr (phasa.x    , phasa.y + 7) < 64 && 
			attr (phasa.x + 1, phasa.y + 7) < 64 &&
			attr (phasa.x + 2, phasa.y + 7) < 64) {
			phasa.frame = phasa.facing + 9;
			phasa.y ++;
		}
	}
}

void mueve_bicharracos () {
	unsigned char i, n_enem;
	
	// Como mximo hay dos bicharracos que se movern de forma lineal de un 
	// extremo al otro de la pantalla.
	
	for (i = 0; i < 2; i ++)
		if (bicharraco [i].t) {
			
			// Con este sencillo contador y el campo "delay" controlamos
			// la velocidad de los bicharracos. Con "1" se mover un espacio
			// cada frame. Con N, uno cada N frames.
			
			bicharraco [i].ct ++;
			if (bicharraco [i].t == 8 + ingame_offset_enemigos) {
				
				// El tipo 8 es el enemigo explotando
				// (el enemigo explota. Las cosas que explotan hacen risa).
				
				bicharraco [i].frame ++;
				if (bicharraco [i].frame == 4)
					bicharraco [i].t = 0;
			} else {
				if (bicharraco [i].ct == bicharraco [i].delay) {
					bicharraco [i].ct = 0;
					bicharraco [i].x += bicharraco [i].mx;
					if (bicharraco [i].x == -3 || bicharraco [i].x == 32	)
						bicharraco [i].t = 0;
					bicharraco [i].frame = (bicharraco [i].frame + 1) & 3;
				}	
			}
		} else {
			// Vemos si creamos un bicharraco nuevo:
			
			if ((rand () % 20) == 2) {
				n_enem = (rand () % ingame_num_enemigos);
				bicharraco [i].t = 1 + ingame_offset_enemigos + n_enem;
				
				if (!(n_enem & 1) || ingame_auto_advance_me) {
					bicharraco [i].x = 31;
					bicharraco [i].mx = -1;
				} else {
					bicharraco [i].x = -2;
					bicharraco [i].mx = 1;
				}
				bicharraco [i].y = 7 + (rand () % 7);
				bicharraco [i].ct = 0;
				bicharraco [i].delay = 1 + (rand () & 3);
				bicharraco [i].frame = 0;
				bicharraco [i].frame_offset = (bicharraco [i].t - 1) << 2;
			}
		}
}

void mueve_cosas () {
	unsigned char i, aux, j;
	
	for (i = 0; i < 8; i ++)
		if (cosa [i].t) {
			if (cosa [i].x >= campos && cosa [i].x < campos + 32) {
				if (attr (cosa [i].x - campos, cosa [i].y + 1) < 64 && cosa [i].y < 16)
						cosa [i].y ++;
			} else {
				cosa [i].y = 5;
				if (ingame_auto_advance_me && cosa [i].x < campos) {
					cosa [i].x = campos + 32 + (rand () & 63);
					if (cosa [i].x > ingame_last_object_x - 64)
						cosa [i].x = 32 + (rand () & 63);
				}
			}
		} else {
			// Crear nueva cosa:
			cosa [i].y = 5;
			aux = 0;
			do {
				if (ingame_auto_advance_me) {
					cosa [i].x = campos + 32 + (rand () & 63);		
					if (cosa [i].x > ingame_last_object_x - 64)
						cosa [i].x = 32 + (rand () & 63);
				} else
					cosa [i].x = campos - 48 + (rand () & 127);		
				// Hay que elegir otro sitio en el caso de caer dentro de un obst-
				// culo.
				aux = 0;
				for (j = 0; j < ingame_num_obstacles && !aux; j ++)
					if (ingame_obstacles [j].y < 7 && cosa [i].x >= ingame_obstacles [j].x && cosa [i].x < ingame_obstacles [j].x + 4)
						aux = 1;
					else if (ingame_obstacles [j].y == 9 && cosa [i].x == ingame_obstacles [j].x)
						cosa [i].x ++;
					else if (ingame_obstacles [j].y == 9 && cosa [i].x == ingame_obstacles [j].x + 3)
						cosa [i].x --;
			} while (aux || cosa [i].x < 8 || cosa [i].x > ingame_last_object_x);
			
			if (i != 0)
				cosa [i].t = 1;
			else
				cosa [i].t = (rand () & 7) < 4 ? 1 : 2 + (quarterlife & 3);
		}
}

void init_phasa () {
	phasa.y = 10;
	phasa.x = 15;
	phasa.sal = phasa.nu = 0;
	phasa.state = STATE_IDLE;
	phasa.step = 0;
	phasa.frame = 0;
	phasa.facing = 0;
	
	campos = 0;			// de Camera Position, nada de Mara Teresa en??
}

void cuatro_halts () {
	#asm
		halt
		halt
		halt
		halt
	#endasm
}

void menu () {
	halflife = 0;
	uncrunch (TITLE);
	while (!sp_GetKey ()) {
		cuatro_halts ();
		halflife = !halflife;
		if (halflife) {
			for (asm_int = 10; asm_int < 14; asm_int ++) {
			#asm
				call escrolleft
			#endasm
			}
		}
		for (asm_int = 17; asm_int < 20; asm_int ++) {
		#asm
			call escrolleft
		#endasm
		}
	}
}

void exit_sequence () {
	unsigned char i, j, x, y, aux, halflife = 0;
	
	// Exit sequence del conveyor.
	// Se pinta una pared a la derecha,
	// Phantomasa avanza hacia ella,
	// El bichote malo avanza a un cuarto de velocidad
	
	// Pared a la derecha:
	
	put_4x4_tilprite (30, 13, 16);
	put_4x4_tilprite (30, 9, 16);
				
	// Explotar enemigos
	for (i = 0; i < 2; i ++)
		if (bicharraco [i].t) {
			bicharraco [i].t = 8 + ingame_offset_enemigos;
			bicharraco [i].frame = 0;
			bicharraco [i].frame_offset = (bicharraco [i].t - 1) << 2;
			peta_el_beeper (5);
		}
	
	// Borrar bullets:
	for (i = 0; i < NUM_BULLETS; i ++)
		if (bullet [i].status)
			sp_PrintAtInv (bullet [i].y, bullet [i].x, 9, 0);
	
	// Borrar cosas: 
	for (i = 0; i < 8; i ++)
		if (cosa [i].x >= campos && cosa [i].x < campos + 32 && cosa [i].t)
			sp_PrintAtInv (cosa [i].y, cosa [i].x - campos, 9, 0);
	
	// Explosiones
	for (j = 0; j < 4; j ++) {
		cuatro_halts ();
		
		for (i = 0; i < 2; i ++)
			if (bicharraco [i]) {
				bicharraco [i].frame ++;
				put_3x3_tilprite (bicharraco [i].x, bicharraco [i].y, bicharraco_g [bicharraco [i].frame + bicharraco [i].frame_offset]);	
			}
		
		sp_UpdateNow ();
	} 
	
	for (i = 0; i < 2; i ++) 
		del_3x3_tilprite (bicharraco [i].x, bicharraco [i].y);				
	
	// Avance
	
	aux = 0;
	x = 0;
	
	while (phasa.x < 27) {
		cuatro_halts ();
		
		del_3x7_tilprite (phasa.x, phasa.y);
		del_3x7_tilprite (x, 10);
		
		aux = (aux + 1) & 3;
		if (aux == 0)
			x ++;
		
		phasa.y = 10;
		
		if (!(phasa.step & 1)) {	// Par				
			phasa.x ++;
		} else {
			phasa.x +=2;
		}
	
		phasa.step = (phasa.step + 1) & 3;
	
		if (phasa.step == 1)
			phasa.frame = 2;
		else if (phasa.step == 3)
			phasa.frame = 3;
		else
			phasa.frame = 1;
	
		put_3x7_tilprite (phasa.x, phasa.y, phasa.frame);
		put_3x7_tilprite (x, 10, 12 + halflife);
		
		halflife = !halflife;
	
		sp_UpdateNow ();
	}
	
	// Cae una caja sobre el bichazo
	
	y = 5;
	for (i = 5; i < 13; i ++) {
		cuatro_halts ();
		del_4x4_tilprite (x - 1, y);
		y ++;
		put_4x4_tilprite (x - 1, y, 14);
		sp_UpdateNow ();	
	}
	
	peta_el_beeper (2);
	
	for (i = 0; i < 4; i ++)
		cuatro_halts ();
		
	peta_el_beeper (2);	
}

char espera_activa (int espera) {
	// Esta funcin espera un rato o hasta que se pulse una tecla.
	// Si se pulsa una tecla, devuelve 0
	
	// Esta funcin slo funciona en Spectrum (espera 10 segundos).
	// en CPC no hay una interrupcin cada 20ms, asn que esto no
	// sirve "pa n".
	
	char res = 1;
	int i;
	
	for (i = 0; i < espera && res; i ++) {
		#asm
			halt
		#endasm
		if (sp_GetKey ()) 
			res = 0;
	}
	
	return res;
}

void interlude (unsigned int got, unsigned int togo) {
	sp_UpdateNow ();
	if (fase < 3) {
		uncrunch (INTERLUDE);
		print_int (18, 11, 79, got);
		print_int (18, 13, 79, togo);
	} else {
		uncrunch (ESCAPE);
	}
	sp_UpdateNow ();
	espera_activa (32767);
}

unsigned char playthegame () {
		
	// Juega a la fase actualmente definida. Biban las globales. Hoygan.
	
	unsigned char i, j, x, y;
	unsigned char flag1 = 0, flag2 = 0;
	unsigned char aux, changing;
	unsigned char aux_tiles;
	unsigned char result = 0;
	unsigned char times;
	unsigned int current_score;
	unsigned int increment = 5000;
	
	current_score = phasa.score;
	
	// Definimos los tiles de esta fase:
	
	allpurposepuntero = ingame_tiles;
	for (aux_tiles = 152; aux_tiles < 240; aux_tiles++) {
		sp_TileArray ((unsigned char)aux_tiles, allpurposepuntero);
		allpurposepuntero += 8;
	}
		
	// Empezamos
	
	flag1 = 0;
	times = 0;
	
	init_phasa ();
	
	interlude (current_score, current_score + increment);
	sp_ClearRect(sp_ClipStruct, 9, 0, sp_CR_TILES);
	sp_UpdateNow ();
	uncrunch (ingame_backdrop);
		
	// get bk;
	
	rectangulo.height = 7;
	rectangulo.width = 3;
	rectangulo.row_coord = phasa.y;
	rectangulo.col_coord = phasa.x;
	sp_GetTiles (&rectangulo, buffer_phasa);
	
	rectangulo_enem.width = rectangulo_enem.height = 3;
	
	marcador_lives ();
	marcador_power ();
	marcador_bullets ();
	marcador_score ();
	
	// Crear los 10 objetos: un bullets/power y 9 nineros.
	
	for (i = 0; i < 8; i ++) {
		cosa [i].t = 1;
		cosa [i].status = 0;
		
		cosa [i].y = 5;
		
		do {
			cosa [i].x = 24 + 2 * rand ();	
			
			// Hay que elegir otro sitio en el caso de caer dentro de un obst-
			// culo.
			
			aux = 0;
			for (j = 0; j < ingame_num_obstacles && !aux; j ++)
				if (ingame_obstacles [j].y < 7 && cosa [i].x >= ingame_obstacles [j].x && cosa [i].x < ingame_obstacles [j].x + 4)
					aux = 1;
				else if (ingame_obstacles [j].y == 9 && cosa [i].x == ingame_obstacles [j].x)
					cosa [i].x ++;
				else if (ingame_obstacles [j].y == 9 && cosa [i].x == ingame_obstacles [j].x + 3)
					cosa [i].x --;
					
		} while (aux || cosa [i].x > ingame_last_object_x);
	}
	
	cosa [0].t = 2;
	
	while (!flag1) {
		halflife = !halflife;
		if (halflife) quarterlife = !quarterlife;
		
		// ***************************************************************
		// Borrar mierda
		// ***************************************************************
		
		// Ejcrol:
		for (i = 0; i < ingame_num_obstacles; i ++) 
			if (ingame_obstacles [i].x >= campos - 4 && ingame_obstacles [i].x <= campos + 32)
				del_4x4_tilprite (ingame_obstacles [i].x - campos, ingame_obstacles [i].y);	
				
		// Phantomasa		
		del_3x7_tilprite (phasa.x, phasa.y);	
		
		// Enemigos:
		for (i = 0; i < 2; i ++)
			if (bicharraco [i].t) 
				del_3x3_tilprite (bicharraco [i].x, bicharraco [i].y);
				
		// Bullets:
		for (i = 0; i < NUM_BULLETS; i ++)
			if (bullet [i].status)
				sp_PrintAtInv (bullet [i].y, bullet [i].x, 9, 0);
		
		// Bicho perseguidor:
		/*if (ingame_auto_advance_me)
			del_3x7_tilprite (0, 10);*/
						
		// Cosas: 
		for (i = 0; i < 8; i ++)
			if (cosa [i].x >= campos && cosa [i].x < campos + 32 && cosa [i].t)
				sp_PrintAtInv (cosa [i].y, cosa [i].x - campos, 9, 0);
		
		// ***************************************************************
		// Mover mierda
		// ***************************************************************
		
		mueve_cosas ();
		mueve ();
		mueve_bicharracos ();
		mueve_bullets ();
		
		// ***************************************************************
		// Pintar Mierda:
		// ***************************************************************
		
		// Ejcrol
		for (i = 0; i < ingame_num_obstacles; i ++) 
			if (ingame_obstacles [i].x >= campos - 4 && ingame_obstacles [i].x <= campos + 32)
				put_4x4_tilprite (ingame_obstacles [i].x - campos, ingame_obstacles [i].y, ingame_obstacles [i].t);		
		
		// Phantomasa
		put_3x7_tilprite (phasa.x, phasa.y, phasa.frame);
		
		// Enemigos
		for (i = 0; i < 2; i ++)
			if (bicharraco [i].t) 
				put_3x3_tilprite (bicharraco [i].x, bicharraco [i].y, bicharraco_g [bicharraco [i].frame + bicharraco [i].frame_offset]);
						
		// Bullets:
		for (i = 0; i < NUM_BULLETS; i ++)
			if (bullet [i].status)
				sp_PrintAtInv (bullet [i].y, bullet [i].x, 22, 159);
		
		// Bicho perseguidor:
		if (ingame_auto_advance_me)
			put_3x7_tilprite (0, 10, 12 + halflife);
				
		// Cosas: 
		for (i = 0; i < 8; i ++)
			if (cosa [i].x >= campos && cosa [i].x < campos + 32 && cosa [i].t)
				sp_PrintAtInv (cosa [i].y, cosa [i].x - campos, cosa_c [cosa [i].t], cosa_g [cosa [i].t]);
				
		// ***************************************************************
		// Hacer comprobaciones:
		// ***************************************************************
		
		// Colisiones bullets-enemigos
		for (i = 0; i < NUM_BULLETS; i ++)
			if (bullet [i].status)
				for (j = 0; j < 2; j ++)
					if (bicharraco [j].t)
						if (bullet [i].x >= bicharraco [j].x     && 
							bullet [i].x <= bicharraco [j].x + 2 &&
							bullet [i].y >= bicharraco [j].y     &&
							bullet [i].y <= bicharraco [j].y + 2) {
							bicharraco [j].t = 8 + ingame_offset_enemigos;
							phasa.score += 25;
							bullet [i].status = 0;
							bicharraco [j].frame = 0;
							bicharraco [j].frame_offset = (bicharraco [j].t - 1) << 2;	
							marcador_score ();
							peta_el_beeper (0);
						}
		
		// Colisiones enemigos-phasa
		for (i = 0; i < 2; i ++)
			if (bicharraco [i].t != 0 && bicharraco [i].t != 8 + ingame_offset_enemigos) {
				if (bicharraco [i].x >= phasa.x - 1 &&
					bicharraco [i].x <= phasa.x + 1 &&
					bicharraco [i].y >= phasa.y - 1 + (phasa.state == STATE_WDOWN) + (phasa.state == STATE_WDOWN) &&
					bicharraco [i].y < phasa.y + 7 - phasa.sal) {
					bicharraco [i].t = 8 + ingame_offset_enemigos;
					bicharraco [i].frame = 0;
					bicharraco [i].frame_offset = (bicharraco [i].t - 1) << 2;
					phasa.power --;
					peta_el_beeper (4);
					if (phasa.power < 0) {
						// Phasa se muere. Pintar una crux
						// y algn pitazo o explosion guarra.
						del_3x7_tilprite (phasa.x, phasa.y);
						put_3x7_tilprite (phasa.x, 10, 11);
						sp_UpdateNow ();
						kjjjj ();
						del_3x7_tilprite (phasa.x, 10);
						phasa.lives --;
						phasa.power = INI_POWER;
						if (phasa.bullets < 10)
							phasa.bullets = 10;
						if (phasa.lives >= 0) {
							current_score = phasa.score;
							interlude (current_score, current_score + increment);
							sp_ClearRect(sp_ClipStruct, 9, 0, sp_CR_TILES);
							sp_UpdateNow ();
							uncrunch (ingame_backdrop);
							marcador_lives ();
							marcador_power ();
							marcador_bullets ();
							current_score = phasa.score;
							marcador_score ();
						}						
					}
					marcador_power ();			
				}
			}
			
		// Colisiones cosas-phasa
		
		for (i = 0; i < 8; i ++)
			if (cosa [i].t) {
				x = cosa [i].x - campos;
				if (x >= phasa.x     &&
					x <= phasa.x + 2 &&
					cosa [i].y >= phasa.y + (phasa.state == STATE_WDOWN) &&
					cosa [i].y <= phasa.y + 7 - phasa.sal) {
					switch (cosa [i].t) {
						case 1:
							phasa.score += 100;
							marcador_score ();
							peta_el_beeper (1);
							break;
						case 2:
							phasa.bullets += 5;
							if (phasa.bullets > MAX_BULLETS)
								phasa.bullets = MAX_BULLETS;
							marcador_bullets ();
							peta_el_beeper (6);
							break;
						case 3:	
							phasa.power += INI_POWER;
							if (fase == 3) {
								if (phasa.power > (INI_POWER + INI_POWER))
									phasa.power = INI_POWER + INI_POWER;
							} else {
								if (phasa.power > INI_POWER)
									phasa.power = INI_POWER;
							}
							marcador_power ();
							peta_el_beeper (7);
					}
					cosa [i].t = 0;
				}
			}
		
		// Muerte por cogecin del bicho feo perseguidor:
		
		if (ingame_auto_advance_me && phasa.x == 0) {
			kjjjj ();
			phasa.lives --;
			phasa.power = 10;
			if (phasa.bullets < 10)
				phasa.bullets = 10;
			if (phasa.lives >= 0) {
				interlude (current_score, current_score + increment);
				sp_ClearRect(sp_ClipStruct, 9, 0, sp_CR_TILES);
				sp_UpdateNow ();
				uncrunch (ingame_backdrop);
				marcador_lives ();
				marcador_power ();
				marcador_bullets ();
				marcador_score ();
			}
			
			for (i = 6; i < 17; i ++)
				for (j = 0; j < 32; j ++)
					sp_PrintAtInv (i, j, 9, 0);
			
			init_phasa ();
		}
		
		// Roll scroll
		
		if (ingame_auto_advance_me && campos >= ingame_last_object_x + 32) {
			campos = -32;
			times ++;
		}
		
		// Condiciones de guego:
		
		if (phasa.lives < 0) {
			result = 1;
			flag1 = 1;
		}
		
		if (ingame_auto_advance_me && times == 3) {
			exit_sequence ();			
			flag1 = 1;
		}
		
		if (!ingame_auto_advance_me && phasa.score > increment + current_score) {
			flag1 = 1;	
		}
								
		// ***************************************************************
		// Blit
		// ***************************************************************
		
		sp_UpdateNow ();
	}	
	
	return result;	// 0 = OK, 1 = GAMEOVER, 2 = ABORT. O algo.
}

void main (void)
{
	unsigned char i, j, x, y;
	int aux_tiles;
	unsigned char game;
	
	#asm
		di
	#endasm
	
	// Inicializacin de la biblioteca splib2

	sp_Initialize (0, 9);
	sp_Border (BLACK);
	
	keys.up    = sp_LookupKey ('q');
	keys.down  = sp_LookupKey ('a');
	keys.left  = sp_LookupKey ('o');
	keys.right = sp_LookupKey ('p');
	keys.fire  = sp_LookupKey (' ');
		
	// Empezamos!
		
	while (1) {
		menu ();
		
		phasa.lives = INI_LIVES;
		phasa.power = INI_POWER;
		phasa.bullets = 10;
		phasa.score = 0;
		
		// To estos tiestos los podemos meter en un array 
		// de estructuras...
		
		fase = 0;
		game = 1;
		
		while (game) {
			ingame_backdrop 		= fases [fase].backdrop;
			ingame_obstacles 		= fases [fase].obstacles;
			ingame_num_obstacles 	= fases [fase].num_obstacles;
			ingame_last_object_x 	= fases [fase].last_object_x;
			ingame_offset_enemigos 	= fases [fase].offset_enemigos;
			ingame_num_enemigos 	= fases [fase].num_enemigos;
			ingame_tiles 			= fases [fase].tiles;
			ingame_auto_advance_me	= fases [fase].auto_advance_me;
			
			// Definimos los grficos generales (Phantomasa y la gaita del GUI).
			
			for (i = 0; i < 2; i ++)
				bicharraco [i].t = 0;
			
			allpurposepuntero = gfx_tiles;
			for (aux_tiles = 0; aux_tiles < 152; aux_tiles++) {
				sp_TileArray ((unsigned char)aux_tiles, allpurposepuntero);
				allpurposepuntero += 8;
			}
			
			for (aux_tiles = 240; aux_tiles < 256; aux_tiles++) {
				sp_TileArray ((unsigned char)aux_tiles, allpurposepuntero);
				allpurposepuntero += 8;
			}
			
			// Jugar el juego. Cagar la caca.
			
			i = playthegame ();
			if (!i) {
				fase ++;
				if (fase == 4)
					game = 0;
			} else {
				game = 0;	
			}
			
			if (fase != 4) {
				// GAME OVER SCREEN
			} else {
				// FINAL
				uncrunch (ENDING);
				while (!sp_GetKey ());
			}	
		} 
		
		// Comprobar i y actuar en consecuencia.
	}		
}

// Includes de grficos y dems tiestamen.

#include "tiles.h"

/*
	"Fundamentally Loathsome"
	(Words & Music by Marilyn Manson)
	
	I want to wake up in your white, white sun
	I want to wake up in your world with no pain
	But I'll just suffer in a hope to die someday
	While you are numb all of the way
	
	When I hate it I know I can feel but
	When you love it you know it's not real
	No
	And I am resigned to this wicked fucking world
	On its way to hell
	The living are dead and
	I hope to join them too
	I know what to do and I do it well...
	
	When I hate it I know I can feel but
	When you love it you know it's not real
	No
	
	Shoot myself to love you
	If I loved myself I'd be shooting you
*/
